local FU = FRACUNIT

freeslot("MT_DRIFTELEC", "S_DRIFTELEC", "SPR_DREL")
states[S_DRIFTELEC] = {
	frame = A|FF_PAPERSPRITE|FF_FULLBRIGHT,
	sprite = SPR_DREL,
	tics = -1,
	nextstate = S_DRIFTELEC,
}
mobjinfo[MT_DRIFTELEC] = {
	doomednum = -1,
	radius = 16*FU,
	height = 32*FU,
	spawnstate = S_DRIFTELEC,
	spawnhealth = 1,
	flags = MF_NOBLOCKMAP|MF_NOCLIPHEIGHT|MF_NOCLIP|MF_NOCLIPTHING|MF_NOGRAVITY|MF_SCENERY|MF_DONTENCOREMAP,
}

freeslot("MT_DRIFTELECTRICSPARK", "S_DRIFTELECTRICSPARK", "SPR_DRES")
states[S_DRIFTELECTRICSPARK] = {
	frame = A|FF_FULLBRIGHT|FF_PAPERSPRITE|FF_ANIMATE,
	sprite = SPR_DRES,
	tics = 20,
}
mobjinfo[MT_DRIFTELECTRICSPARK] = {
	doomednum = -1,
	speed = 4*FU,
	radius = 9*FU,
	height = 37*FU,
	spawnstate = S_DRIFTELECTRICSPARK,
	spawnhealth = 1,
	flags = MF_NOBLOCKMAP|MF_NOCLIPHEIGHT|MF_NOCLIP|MF_NOCLIPTHING|MF_NOGRAVITY|MF_SCENERY|MF_DONTENCOREMAP,
}

freeslot("MT_BRAKEDUST", "S_BRAKEDUST1", "S_BRAKEDUST2", "SPR_RRBK")
states[S_BRAKEDUST1] = {
	frame = A,
	sprite = SPR_RRBK,
	tics = 1,
	nextstate = S_BRAKEDUST2
}
states[S_BRAKEDUST2] = {
	frame = A|FF_ANIMATE,
	sprite = SPR_RRBK,
	tics = 7,
	var1 = 6,
	var2 = 1
}
mobjinfo[MT_BRAKEDUST] = {
	doomednum = -1,
	reactiontime = 8,
	speed = 8,
	radius = 8*FU,
	height = 8*FU,
	spawnstate = S_BRAKEDUST1,
	spawnhealth = 1,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_DONTENCOREMAP,
}

freeslot("MT_DRIFTEXPLODE", "SPR_DBOS", "SPR_DBST")
for i = 1,8
	freeslot("S_DRIFTEXPLODE"..i)
end
for i = 1,8
	local state = S_DRIFTEXPLODE1 + (i - 1)
	
	states[state] = {
		frame = FF_FULLBRIGHT|((i % 2 == 0) and FF_PAPERSPRITE or 0)|((i+1)/2 - 1),
		sprite = (i % 2 == 0) and SPR_DBST or SPR_DBOS,
		tics = 1,
		var1 = 6,
		var2 = 1,
		nextstate = (i == 8) and S_DRIFTEXPLODE1 or state + 1
	}
end
mobjinfo[MT_DRIFTEXPLODE] = {
	doomednum = -1,
	spawnstate = S_DRIFTEXPLODE1,
	spawnhealth = 1000,
	speed = 8,
	radius = 32*FU,
	height = 64*FU,
	dispoffset = 1,
	mass = 100,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_DONTENCOREMAP
}

-- lul
freeslot("sfx_cock")

SIMPLE_ANIMAL_DEFINITIONS["rrsonic"] = {
  ["goal"] = {S},
  ["stand"] = {A, B},
  ["stand_left"] = {C, D},
  ["stand_right"] = {E, F},
  ["walk"] = {J, G},
  ["walk_left"] = {K, H},
  ["walk_right"] = {L, I},
  ["run"] = {T, J},
  ["run_left"] = {26 /* '[' */, K},
  ["run_right"] = {27 /* '+' */, L},
  ["drift_left"] = {M, N},
  ["drift_left_in"] = {U, N, V, N},
  ["drift_left_out"] = {W, N},
  ["drift_right"] = {O, P},
  ["drift_right_in"] = {X, P, Y, P},
  ["drift_right_out"] = {Z, P},
  ["spin"] = {Q},
  ["pain"] = {Q},
  ["squish"] = {R},
  ["dead"] = {28 /* ']' */}
}
--SIMPLE_ANIMAL_DEFINITIONS["ringracer"] = SIMPLE_ANIMAL_DEFINITIONS["rrsonic"]
 
local SKINS = {
	["rrsonic"] = true,
	--["ringracer"] = true,
}
local function isRRSkin(mo)
	return (SKINS[mo.skin] == true or (mo.localskin and SKINS[mo.localskin] == true))
end
local function skinIsLocal(mo)
	return isRRSkin(mo) and (SKINS[mo.skin] ~= true)
end

local function MoveDriftElec(spark,me,p)
	local vertrad = me.radius / 3
	local horizrad = me.radius * 5/3
	local vertang = R_PointToAngle2(0,0, me.momx,me.momy) + ANGLE_180
	
	do
		local i = spark.threshold
		local horizang = vertang + (i and ANGLE_90 or ANGLE_270)
		local sparkang = vertang + ANGLE_180
		local scalefac = 0
		local x,y
		
		if p.kartstuff[k_drift] ~= 0
			scalefac = -(2*i - 1) * min(max(p.cmd.driftturn, -1),1) *FU
			if (p.kartstuff[k_drift] > 0) == (not i)
				vertrad = 0
			end
		end
		
		x = P_ReturnThrustX(nil, vertang, vertrad)
			+ P_ReturnThrustX(nil, horizang, horizrad)
		y = P_ReturnThrustY(nil, vertang, vertrad)
			+ P_ReturnThrustY(nil, horizang, horizrad)
			
		P_MoveOrigin(spark, me.x + x, me.y + y, me.z)
		spark.angle = sparkang
		spark.spritexscale = FU + scalefac/3
		spark.spriteyscale = FU + scalefac/8
		
		spark.frame = ($ &~FF_FRAMEMASK)|((leveltime/2) % 6)
	end
	
	spark.eflags = ($ &~MFE_VERTICALFLIP)|(me.eflags & MFE_VERTICALFLIP)
	spark.flags2 = ($ &~MF2_OBJECTFLIP)|(me.eflags & MF2_OBJECTFLIP)
end

local function K_SpawnDriftElectricSparks(p,color)
	local me = p.mo
	local momangle = R_PointToAngle2(0,0,me.momx,me.momy) + ANGLE_180
	-- P_SpawnMobjFromMobj will NOT rescale, because it doesnt exist
	local radius = 2 * me.radius
	local x = P_ReturnThrustX(nil, momangle, radius)
	local y = P_ReturnThrustY(nil, momangle, radius)
	local z = FixedDiv(me.height, 2*FU)
	
	local sparkspeed = mobjinfo[MT_DRIFTELECTRICSPARK].speed
	local sparkradius = 2 * mobjinfo[MT_DRIFTELECTRICSPARK].radius
	sparkradius = FixedMul($, me.scale)
	
	for hdir = -1,1,2
		for vdir = -1,1,2
			local hspeed = FixedMul(hdir * sparkspeed, me.scale)
			local vspeed = vdir * sparkspeed
			local sparkangle = me.angle + ANGLE_45
			
			for i = 0,3
				local xoff = P_ReturnThrustX(nil, sparkangle, sparkradius)
				local yoff = P_ReturnThrustY(nil, sparkangle, sparkradius)
				local spark = P_SpawnMobj(
					me.x + x + xoff,
					me.y + y + yoff,
					me.z + z, MT_DRIFTELECTRICSPARK
				)
				if me.eflags & MFE_VERTICALFLIP
					spark.eflags = $|MFE_VERTICALFLIP
					spark.flags2 = $|MF2_OBJECTFLIP
					
					spark.z = me.z + me.height - z - spark.height
				end
				spark.angle = sparkangle
				spark.color = color
				P_InstaThrust(spark, me.angle + ANGLE_90, hspeed)
				P_SetObjectMomZ(spark, vspeed)
				spark.momx = $ + me.momx
				spark.momy = $ + me.momy
				spark.momz = $ + me.momz
				spark.destscale = me.scale
				spark.scale = spark.destscale
				
				sparkangle = $ + ANGLE_90
			end
		end
	end
end

local function P_GetMobjZMovement(mo)
	local slope = mo.standingslope
	local angDiff
	local speed

	if not (P_IsObjectOnGround(mo))
		return mo.momz
	end
	
	if not (slope)
		return 0
	end
	
	angDiff = R_PointToAngle2(0, 0, mo.momx, mo.momy) - slope.xydirection
	speed = FixedHypot(mo.momx, mo.momy)

	return P_ReturnThrustY(mo, slope.zangle, P_ReturnThrustX(mo, angDiff, speed))
end

local function K_GetBrakeFXScale(p, maxscale)
	local speed = FixedDiv(p.speed, K_GetKartSpeed(p, false))
	speed = max($, FU)
	speed = min($, maxscale)
	return speed
end
local function spawn_brake_dust(me, aoff, rad, scale)
	local angle = me.angle + aoff
	rad = FixedMul($, me.scale)
	local spark = P_SpawnMobj(
		me.x + P_ReturnThrustX(nil, angle, rad),
		me.y + P_ReturnThrustY(nil, angle, rad),
		me.z, MT_BRAKEDUST
	)
	if me.eflags & MFE_VERTICALFLIP
		spark.eflags = $|MFE_VERTICALFLIP
		spark.flags2 = $|MF2_OBJECTFLIP
		
		spark.z = me.z + me.height - z - spark.height
	end
	spark.destscale = me.scale
	spark.scale = spark.destscale
	
	spark.momx = me.momx
	spark.momy = me.momy
	spark.momz = P_GetMobjZMovement(me)
	spark.angle = angle - ANGLE_180
	spark.pitch = me.pitch
	spark.roll = me.roll
	spark.slopepitch = me.slopepitch
	spark.sloperoll = me.sloperoll
	
	P_Thrust(spark, angle, 16*spark.scale)
	spark.destscale = FixedMul(scale, spark.scale)
	spark.target = me
end

local function K_SpawnBrakeVisuals(p, kart)
	local scale = K_GetBrakeFXScale(p, 2*FU)
	local me = p.mo
	
	if (leveltime & 1)
		local aoff
		local radf
		
		local wheel = 3
		
		if (kart[k_drift])
			wheel = $^^(1 << (kart[k_drift] < 0 and 1 or 0))
			
			aoff = 7 * ANG10
			radf = 32*FU
		else
			aoff = ANG30
			radf = 24*FU
		end
		
		if wheel & 1
			spawn_brake_dust(me, aoff, radf, scale)
		end
		if wheel & 2
			spawn_brake_dust(me, InvAngle(aoff), radf, scale)
		end
	end
	
	if (leveltime % 4 == 0)
		S_StartSoundAtVolume(me, sfx_s3k67,
			(kart[k_brakedrift] and 255/2 or 255),
			p
		)
	end
	
	if me.spriteyoffset ~= nil
		if leveltime & 1
			me.spriteyoffset = 4 * scale
		else
			me.spriteyoffset = 0
		end
	end
	me.braking = true
end

local function K_SpawnDriftBoostExplosion(p, stage)
	local me = p.mo
	-- we spawn 2 to fix the weird interp stuff
	for i = 0,1
		local overlay = P_SpawnMobj(me.x,me.y,me.z, MT_DRIFTEXPLODE)
		overlay.angle = R_PointToAngle2(0,0,me.momx,me.momy)
		overlay.target = me
		overlay.destscale = me.scale * 9/10
		P_SetScale(overlay, overlay.destscale)
		if me.eflags & MFE_VERTICALFLIP
			overlay.eflags = $|MFE_VERTICALFLIP
			overlay.flags2 = $|MF2_OBJECTFLIP
			
			overlay.z = me.z + me.height - z - overlay.height
		end
		
		if stage == 1
			overlay.fuse = 16
		elseif stage == 2
			overlay.fuse = 32
		elseif stage == 3
			overlay.fuse = 48
		elseif stage == 4
			overlay.fuse = 120
		else
			overlay.fuse = 16
		end
		overlay.extravalue1 = stage
		overlay.extravalue2 = i
		if i
			overlay.flags2 = $|MF2_DONTDRAW
		end
	end
end

SIMPLE_ANIMAL_HOOKS.rrsonic_drift = function(me, seq)
	if not(me and me.valid) then return end
	local isrr = isRRSkin(me)
	
	if not isrr then return end
	if me.type ~= MT_PLAYER then return end
	if (me.sprite ~= SPR_PLAY) then return end
	
	local p = me.player
	local kart = p.kartstuff
	local sstage = K_GetKartDriftSparkValue(p)
	local helpers = _G["SIMPLE_ANIMAL_HELPERS"]
	local animation
	local islocal = skinIsLocal(me)
	
	local grounded = true
	if not P_IsObjectOnGround(me)
		grounded = false
	end
	if (me.spriteyoffset ~= nil)
		if me.spriteyoffset ~= 0 then grounded = false; end
	end
	if kart[k_pogospring]
		grounded = true
	end
	
	if not me.health
		me.pitch,me.roll,me.slopepitch,me.sloperoll = 0,0,0,0
		return "dead"
	end
	
	local wasbraking = me.braking
	me.braking = false
	if (p.cmd.buttons & BT_BRAKE or kart[k_brakedrift])
	and P_IsObjectOnGround(me)
	and (p.speed > me.scale)
		if not kart[k_brakestop]
			K_SpawnBrakeVisuals(p,kart)
		end
	end
	if not me.braking
	and wasbraking
	and me.spriteyoffset ~= nil
		me.spriteyoffset = 0
	end
	
	if kart[k_drift] ~= 0
	and me.health
		if helpers.isPained(me) then grounded = false; end
		
		if grounded
			-- 1 = left, -1 = right
			local driftdir = (kart[k_drift] < 0 and -1 or 1)
			local turndir = p.cmd.driftturn ~= 0 and (p.cmd.driftturn < 0 and -1 or 1) or 0
			local dir = driftdir == -1 and "right" or "left"
			
			if (turndir ~= 0)
			and (me.health)
				if driftdir == turndir
					animation = "drift_"..dir.."_in"
				else
					animation = "drift_"..dir.."_out"
				end
			end
			
			if kart[k_driftcharge] >= sstage*3
			and kart[k_driftcharge] < sstage*4
				if not me.rr_thirdstage
					S_StartSoundAtVolume(me,sfx_s3ka2,192)
					me.rr_size = 8
					
					for i = 0,1
						local sp = P_SpawnMobj(me.x,me.y,me.z,MT_DRIFTELEC)
						P_SetScale(sp, me.scale, true)
						sp.target = me
						sp.threshold = i
						
						MoveDriftElec(sp,me,p)
						P_SetOrigin(sp, sp.x,sp.y,sp.z)
						
						if (i & 1)
							me.drel_1 = sp
						else
							me.drel_0 = sp
						end
					end
				end
				
				me.rr_thirdstage = true
			else
				me.rr_thirdstage = nil
			end
			if kart[k_driftcharge] >= sstage*4
				if not me.rr_cock
					S_StartSound(me,sfx_cock)
				end
				me.rr_cock = true
			else
				me.rr_cock = nil
			end
		else
			local driftdir = (kart[k_drift] < 0 and -1 or 1)
			local dir = driftdir == -1 and "right" or "left"
			animation = "drift_"..dir
		end
		
		if me.rr_size ~= nil
			me.rr_size = $ - 1
			if me.rr_size == 0 then me.rr_size = nil; end
		end
	else
		local slowspeed = K_GetKartSpeed(p,false) * 17/20
		
		if grounded
			if p.speed <= slowspeed
				if seq[1] == "run_left"
					animation = "walk_left"
				elseif seq[1] == "run_right"
					animation = "walk_right"
				elseif seq[1] == "run"
					animation = "walk"
				end
			end
		else
			if seq[1]:find("_left")
				animation = "run_left"
			elseif seq[1]:find("_right")
				animation = "run_right"
			elseif seq[1] == "walk"
				animation = "run"
			end
		end
	end
	
	if me.rr_lastboost == nil then me.rr_lastboost = 0 end
	if (kart[k_driftboost]
	and me.rr_lastboost == 0)
	or (kart[k_driftboost] > me.rr_lastboost)
		local release_stage = 1
		
		if (me.rr_lastspark >= sstage*2)
		and me.rr_lastspark < sstage*3
			S_StartSound(me,sfx_kc5b)
			release_stage = 2
		elseif me.rr_lastspark >= sstage*3
		and me.rr_lastspark < sstage*4
			
			if not islocal
				if kart[k_driftboost] < 85
					kart[k_driftboost] = 85
				end
			end
			S_StartSound(me,sfx_kc5b)
			S_StartSound(me,sfx_s3k45)
			K_SpawnDriftElectricSparks(p, SKINCOLOR_BLUE, false)
			release_stage = 3
		elseif me.rr_lastspark >= sstage*4
			S_StartSound(me,sfx_kc5b)
			S_StartSound(me,sfx_s3kc4l)
			S_StartSound(me,sfx_s3k45)
			K_SpawnDriftElectricSparks(p, 1 + (leveltime % (MAXSKINCOLORS - 1)), false)
			release_stage = 4
		end
		K_SpawnDriftBoostExplosion(p, release_stage)
		
		if (me.drel_1 and me.drel_1.valid)
			P_RemoveMobj(me.drel_1)
			me.drel_1 = nil
		end
		if (me.drel_0 and me.drel_0.valid)
			P_RemoveMobj(me.drel_0)
			me.drel_0 = nil
		end
		if P_IsObjectOnGround(me)
			me.rr_drift = nil
		end
	end
	if P_IsObjectOnGround(me)
		me.rr_lastspark = kart[k_driftcharge]
	end
	me.rr_lastboost = kart[k_driftboost]
	
	return animation
end

local SPARK_NEWCOLORS = {
	[SKINCOLOR_SAPPHIRE] = SKINCOLOR_GOLD,
	[SKINCOLOR_RASPBERRY] = SKINCOLOR_SCARLET,
	--SKINCOLOR_KETCHUP
}
local SPARK_PULSE = FixedDiv(FU, 8*FU)
local SPARK_THINKER = function(spark)
	if not (spark and spark.valid) then return end
	local me = spark.target
	if not (me and me.valid) then return end
	local p = me.player
	if not (p and p.valid) then return end
	--if (me.skin ~= "rrsonic") then return end
	if not isRRSkin(me) then return end
	
	--dont change rainbow sparks
	local stage = K_GetKartDriftSparkValue(p)
	if (p.kartstuff[k_driftcharge] >= stage*4) then return end
	
	if SPARK_NEWCOLORS[spark.color] ~= nil
		spark.color = SPARK_NEWCOLORS[$]
	end
	
	if me.rr_thirdstage
		if p.kartstuff[k_driftcharge] <= (stage*3) + 24*3
			--transition
			spark.color = SKINCOLOR_MOONSLAM
		else
			spark.color = SKINCOLOR_BLUE
		end
	end
	
	if me.rr_size ~= nil
	and (spark.type == MT_DRIFTSPARK)
		spark.scale = me.scale + FixedMul(SPARK_PULSE * me.rr_size, me.scale)
		P_SetScale(spark,spark.scale,true)
	end
end

addHook("MobjThinker",SPARK_THINKER,MT_DRIFTSPARK)

addHook("MobjThinker",function(spark)
	if not (spark and spark.valid) then return end
	local me = spark.target
	if not (me and me.valid) then P_RemoveMobj(spark); return end
	local p = me.player
	if not (p and p.valid) then P_RemoveMobj(spark); return end
	if not isRRSkin(me) then P_RemoveMobj(spark); return end
	if (p.kartstuff[k_drift] == 0) then P_RemoveMobj(spark); return end
	
	MoveDriftElec(spark,me,p)
	
	if (leveltime & 1)
		spark.flags2 = $|MF2_DONTDRAW
	else
		spark.flags2 = $ &~MF2_DONTDRAW
	end
	
	local ds = K_GetKartDriftSparkValue(p)
	local charge = p.kartstuff[k_driftcharge]
	
	if charge >= ds*4
		spark.color = 1 + (leveltime % (MAXSKINCOLORS - 1))
	elseif charge >= ds*3
		if charge <= (ds*3) + 24*3
			--transition
			spark.color = SKINCOLOR_MOONSLAM
		else
			spark.color = SKINCOLOR_BLUE
		end
	elseif charge >= ds*2
		if charge <= (ds*2) + 24*3
			--transition
			spark.color = SPARK_NEWCOLORS[SKINCOLOR_RASPBERRY]
		else
			spark.color = SKINCOLOR_KETCHUP
		end
	else
		spark.color = SPARK_NEWCOLORS[SKINCOLOR_SAPPHIRE]
	end
end,MT_DRIFTELEC)
addHook("MobjThinker",function(spark)
	if not (spark and spark.valid) then return end
	if spark.flags & MF2_DONTDRAW
		spark.flags = $ &~MF2_DONTDRAW
	else
		spark.flags = $|MF2_DONTDRAW
	end
end,MT_DRIFTELECTRICSPARK)

addHook("MobjThinker",function(spark)
	if not (spark and spark.valid) then return end
	if not (spark.target and spark.target.valid)
	or not (spark.target.health)
		P_RemoveMobj(spark)
		return
	end
	local me = spark.target
	
	local nudge = 0
	local angle = R_PointToAngle2(0,0, me.momx,me.momy)
	spark.angle = angle
	
	if (spark.fuse & 1)
		if (spark.extravalue2)
			spark.flags2 = $|MF2_DONTDRAW
		else
			spark.flags2 = $ &~MF2_DONTDRAW
		end
	-- papersprite frame (extravalue2 == 1)
	else
		if (spark.extravalue2)
			spark.flags2 = $ &~MF2_DONTDRAW
		else
			spark.flags2 = $|MF2_DONTDRAW
		end
	end
	
	-- Papersprite
	if (spark.extravalue2)
		nudge = 2 * me.radius
		spark.angle = $ + ANGLE_90
	else
		nudge = 4 * me.radius
	end
	
	P_MoveOrigin(spark,
		me.x + P_ReturnThrustX(nil, angle + ANGLE_180, nudge),
		me.y + P_ReturnThrustY(nil, angle + ANGLE_180, nudge),
		me.z
	)
	P_SetScale(spark, me.scale * 9/10)
	
	spark.pitch = me.pitch
	spark.roll = me.roll
	spark.slopepitch = me.slopepitch
	spark.sloperoll = me.sloperoll
	
	if (spark.fuse <= 16)
		spark.color = SKINCOLOR_GOLD
		if not (spark.fuse & 1)
			spark.flags2 = $|MF2_DONTDRAW
		end
	elseif (spark.fuse <= 32)
		spark.color = SKINCOLOR_KETCHUP
	elseif (spark.fuse <= 48)
		spark.color = SKINCOLOR_SAPPHIRE
	elseif (spark.fuse > 48)
		spark.color = 1 + (leveltime % (MAXSKINCOLORS - 1))
	end
	
end,MT_DRIFTEXPLODE)

local brakedrifts = {}
addHook("MobjSpawn",function(sp)
	table.insert(brakedrifts, sp)
end,MT_BRAKEDRIFT)

addHook("ThinkFrame",do
	for k,mo in ipairs(brakedrifts)
		if not (mo and mo.valid)
			table.remove(brakedrifts,k)
			continue
		end
		
		SPARK_THINKER(mo)
	end
end)
addHook("NetVars",function(n) brakedrifts = n($); end)